#!/usr/bin/env python3

# Input validator

import sys

st = {2, 3, 4, 5, 6, 7, 8, 9}
strats = {'minInfo', 'delayExp'}

fi = open(sys.argv[1], 'rt')
fo = open(sys.argv[2], 'wt')

n = int(fi.readline())
if 2 > n or n > 10_000:
    sys.exit('N out of range')
print(n, file=fo)

b1, b2 = (int(x) for x in fi.readline().split())
if b1 == 0:
    if b2 != 0:
        sys.exit('Invalid B2')
    strat = fi.readline().strip()
    if strat not in strats:
        sys.exit('Invalid strategy')
    print(b1, b2, file=fo)
    print(strat, file=fo)
elif b2 == 0:
    if 1 > b1 or b2 >= n:
        sys.exit('B1 out of range')
    strat = fi.readline().strip()
    if strat not in strats:
        sys.exit('Invalid strategy')
    print(b1, b2, file=fo)
    print(strat, file=fo)
else:
    if 1 > b1 or b1 >= b2 or b2 > n:
        sys.exit('B1, B2 out of range')
    print(b1, b2, file=fo)

if n > 2:
    st.discard(2)
if n > 3:
    st.discard(3)
if n > 10:
    st.discard(4)
if n > 20:
    st.discard(5)
if n > 50:
    st.discard(6)
if n > 100:
    st.discard(7)
if b1 != 1:
    st.discard(8)

fi.close()
fo.close()

if len(sys.argv) > 4 and sys.argv[4] == '-v':
    print('subtasks:', *st)
