import sys

# queries whether the set a..b explodes
def check(a, b):
    print('?', end='')
    for i in range(a, b + 1):
        print(' ', i, end='')
    print(flush=True)
    s = input()
    if s == 'ERR':
        sys.exit(0)
    return s == 'EXP'

n = int(input())

# linear search for b1
b1 = 1
while check(b1, n):
    b1 += 1
b1 -= 1

# linear search for b2
b2 = n
while check(b1, b2):
    b2 -= 1
b2 += 1

print('!', b1, b2, flush=True)
