#include <iostream>
#include <string>
using namespace std;

// queries whether the set a..b explodes
bool check(int a, int b) {
	cout << "?";
	for (int i = a; i <= b; ++i) {
		cout << " " << i;
	}
	cout << endl;
	string s;
	cin >> s;
	return s == "EXP";
}

int main() {
	int n, lo, hi;
	cin >> n;

	// binary search for b1
	lo = 1; hi = n;
	while (lo < hi) {
		int mi = (lo + hi + 1) / 2;
		if (check(mi, n)) {
			lo = mi;
		} else {
			hi = mi - 1;
		}
	}
	int b1 = lo;

	// binary search for b2
	lo = b1; hi = n;
	while (lo < hi) {
		int mi = (lo + hi) / 2;
		if (check(b1, mi)) {
			hi = mi;
		} else {
			lo = mi + 1;
		}
	}
	int b2 = lo;

	// answer
	cout << "! " << b1 << " " << b2 << endl;
}
