#!/usr/bin/env python3

# Input validator

import sys

st = {2, 3, 4, 5, 6}

fi = open(sys.argv[1], 'rt')
fo = open(sys.argv[2], 'wt')

n = int(fi.readline())
if 1 > n or n > 1e5:
    sys.exit('N out of range')
print(n, file=fo)

a, r = [], []
for i in range(n):
    ai, ri = (int(x) for x in fi.readline().split())
    if 0 > ai or ai > 1e9:
        sys.exit(f'A[{1 + i}] out of range')
    if 0 > ri or ri >= n:
        sys.exit(f'R[{1 + i}] out of range')
    print(ai, ri, file=fo)
    a.append(ai)
    r.append(ri)

if n > 5 or max(a) > 10:
    st.discard(2)
if n > 1e3:
    st.discard(3)
if min(a) < 1 or max(a) > 1:
    st.discard(4)
if n > 1 and max((r[i] + r[i + 1] for i in range(n - 1))) > 1:
    st.discard(5)

fi.close()
fo.close()

if len(sys.argv) > 4 and sys.argv[4] == '-v':
    print('subtasks:', *st)
