n = int(input())
a = []
r = []
for i in range(n):
    ai, ri = (int(x) for x in input().split())
    a.append(ai)
    r.append(ri)
    
# illumination ranges of lamps
left = sorted([(i - r[i], i) for i in range(n)])
right = sorted([(i + r[i], i) for i in range(n)])

power = [0] * n # required power levels of lamps
lefti, righti = 0, 0 # sliding window
besti = None
intensity = 0 # current light intensity

# loop over pots
for i in range(n):
    # check ranges that have already started
    while lefti < n and left[lefti][0] <= i:
        lampi = left[lefti][1]
        if besti == None or besti + r[besti] < lampi + r[lampi]:
            # this is the best so far
            besti = lampi
        lefti += 1

    a[i] -= intensity # required additional intensity
    if a[i] > 0:
        # get it from the best lamp
        power[besti] += a[i]
        intensity += a[i]

    # ranges that are ending
    while righti < n and right[righti][0] <= i:
        lampi = right[righti][1]
        intensity -= power[lampi]
        righti += 1

# answer
print(sum(power))
