# queries whether the set a..b explodes
def check(a, b):
    print('?', *list(range(a, b + 1)), flush=True)
    return input() == 'EXP'

n = int(input())

# binary search for b1
lo, hi = 1, n
while lo < hi:
	mi = (lo + hi + 1) // 2
	if check(mi, n):
		lo = mi
	else:
		hi = mi - 1
b1 = lo

# binary search for b2
lo, hi = b1, n
while lo < hi:
	mi = (lo + hi) // 2
	if check(b1, mi):
		hi = mi
	else:
		lo = mi + 1
b2 = lo

# answer
print('!', b1, b2, flush=True)
